package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

public abstract class ASN1Encodable implements DEREncodable {
   public static final String DER = "DER";
   public static final String BER = "BER";

   public byte[] getEncoded() {
      ByteArrayOutputStream var1;
      ByteArrayOutputStream var10000 = var1 = new ByteArrayOutputStream;
      var10000.<init>();
      (new ASN1OutputStream(var1)).writeObject(this);
      return var10000.toByteArray();
   }

   public byte[] getEncoded(String encoding) {
      if (encoding.equals("DER")) {
         ByteArrayOutputStream encoding1;
         ByteArrayOutputStream var10000 = encoding1 = new ByteArrayOutputStream;
         var10000.<init>();
         (new DEROutputStream(encoding1)).writeObject(this);
         return var10000.toByteArray();
      } else {
         return this.getEncoded();
      }
   }

   public byte[] getDEREncoded() {
      try {
         return this.getEncoded("DER");
      } catch (IOException var1) {
         return null;
      }
   }

   public int hashCode() {
      return this.toASN1Object().hashCode();
   }

   public boolean equals(Object o) {
      if (this == o) {
         return true;
      } else if (!(o instanceof DEREncodable)) {
         return false;
      } else {
         ASN1Encodable var10000 = this;
         DEREncodable var2 = (DEREncodable)o;
         return var10000.toASN1Object().equals(var2.getDERObject());
      }
   }

   public DERObject getDERObject() {
      return this.toASN1Object();
   }

   public abstract DERObject toASN1Object();
}
